import java.awt.*;
import java.applet.*;
import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;

class Agenda extends Canvas {

  public Agenda(Color _colorBackground, Color _colorBoundary, Color _colorBuffer, Color _colorLocalOld, Color _colorLocalNew, Color _colorLocalNewChanged) {

    colorBackground = _colorBackground;
    colorBoundary   = _colorBoundary;
    colorBuffer     = _colorBuffer;
    colorLocalOld   = _colorLocalOld;
    colorLocalNew   = _colorLocalNew;
    colorLocalNewChanged = _colorLocalNewChanged;

    setBackground(colorBackground);
    setFont(new Font("Courier", Font.BOLD, 14));

    setBounds(0, 0, 900, 50);
  }

  public void paint(Graphics g) {

    g.setColor(colorBoundary);
    g.fillRect(0, 0, 40, 20);
    g.setColor(Color.black);
    g.drawString("Boundary Value", 45, 15);

    g.setColor(colorBuffer);
    g.fillRect(300, 0, 40, 20);
    g.setColor(Color.black);
    g.drawString("Buffer of Each Processors", 345, 15);

    g.setColor(Color.blue);
    g.fillRect(650, 0, 40, 20);
    g.setColor(Color.black);
    g.drawString("Updated Buffer", 695, 15);

    g.setColor(colorLocalOld);
    g.fillRect(0, 30, 40, 20);
    g.setColor(Color.black);
    g.drawString("Local Data", 45, 45);

    g.setColor(colorLocalNew);
    g.fillRect(300, 30, 40, 20);
    g.setColor(Color.black);
    g.drawString("Not Calculated", 345, 45);

    g.setColor(colorLocalNewChanged);
    g.fillRect(650, 30, 40, 20);
    g.setColor(Color.black);
    g.drawString("New Data", 695, 45);
  }

  public void redraw() {
    repaint();
  }

  protected Color colorBackground;
  protected Color colorBoundary;
  protected Color colorBuffer;
  protected Color colorLocalOld;
  protected Color colorLocalNew;
  protected Color colorLocalNewChanged;
}
