//import javax.swing.*;
import java.awt.*;
import java.util.Vector;

public class ColumnBuffer extends java.awt.Panel {
  public ColumnBuffer(int n, boolean b) {

    nRow = n;

    realBuffer = b;

    setLayout(new GridLayout(nRow*2, 1, 2, 2));
    for ( int i = 0 ; i < nRow ; i++ ) {
      MatrixButton topButton = new MatrixButton();
      if ( realBuffer ) {
	topButton.setBackground(Color.cyan);
      }
      else {
	topButton.setBackground(Color.yellow);
      }
      add(topButton);
      Label tmpLabel = new Label("              ");
      tmpLabel.setFont(new Font("Dialog", Font.PLAIN, 10));
      add(tmpLabel);
    }
  }

  public ColumnBuffer(int n, int _startIndex, int _endIndex, boolean b, Color _colorBackground, Color _colorBuffer) {

    nRow = n;

    startIndex = _startIndex;
    endIndex = _endIndex;

    realBuffer = b;

    colorBackground   = _colorBackground;
    colorBuffer     = _colorBuffer;

    setLayout(new GridLayout(nRow*2, 1, 2, 2));
    for ( int i = 0 ; i < startIndex ; i++ ) {
      MatrixButton topButton = new MatrixButton();
      topButton.setBackground(colorBackground);
      topButton.setForeground(colorBackground);
      add(topButton);
      colBufferItem.addElement(topButton);
      Label tmpLabel = new Label("      ");
      tmpLabel.setFont(new Font("Dialog", Font.PLAIN, 10));
      add(tmpLabel);
    }

    for ( int i = startIndex ; i < endIndex ; i++ ) {
      MatrixButton topButton = new MatrixButton();
      if ( realBuffer ) {
	topButton.setBackground(colorBuffer);
      }
      else {
	topButton.setBackground(colorBackground);
	topButton.setForeground(colorBackground);
      }
      add(topButton);
      colBufferItem.addElement(topButton);
      Label tmpLabel = new Label("      ");
      tmpLabel.setFont(new Font("Dialog", Font.PLAIN, 10));
      add(tmpLabel);
    }

    for ( int i = endIndex ; i < nRow ; i++ ) {
      MatrixButton topButton = new MatrixButton();
      topButton.setBackground(colorBackground);
      topButton.setForeground(colorBackground);
      add(topButton);
      colBufferItem.addElement(topButton);
      Label tmpLabel = new Label("      ");
      tmpLabel.setFont(new Font("Dialog", Font.PLAIN, 10));
      add(tmpLabel);
    }
  }

  /**
  // method       : setTopBackground
  // functionality: sets the background color of the upper 
  //                part of the square
  public void setTopBackground(Color color) {
    topButton.setBackground(color);
  }

  // method       : getTopBackground
  // functionality: returns the background color of the upper 
  //                part of the square
  public Color getTopBackground() {
    return topButton.getBackground();
  }

  // method       : setTopForeground
  // functionality: sets the foreground color of the upper 
  //                part of the square	
  public void setTopForeground(Color color) {
    topButton.setForeground(color);
  }

  // method       : getTopForeground
  // functionality: returns the foreground color of the upper
  //                part of the square
  public Color getTopForeground() {
    return topButton.getForeground();
  }

  // method       : setTopText
  // functionality: sets the text to be display in the upper 
  //                part of the square
  public void setTopText(String text) {
    topButton.setText(text);
  }

  // method       : getTopText
  // functionality: returns the text to be display in the upper
  //                part of the square
  public String getTopText() {
    return topButton.getText();
  }
  **/

  // method       : setText
  // functionality: sets the text to be display in the upper 
  //                part of the square
  public void setText(Vector texts) {
    for ( int i = 0 ; i < colBufferItem.size() ; i++ ) {
      ((MatrixButton)colBufferItem.elementAt(i)).setText((String)texts.elementAt(i));
    }
  }

  public void updateColor() {
    for ( int i = startIndex ; i < endIndex ; i++ ) {
      if ( realBuffer ) {
	((MatrixButton)colBufferItem.elementAt(i)).setBackground(Color.blue);
      }
    }
  }

  // method       : getText
  // functionality: returns the text to be display in the upper
  //                part of the square
  public String getText() {
    return "aa";
  }

  public void returnColor() {
    for ( int i = startIndex ; i < endIndex ; i++ ) {
      if ( realBuffer ) {
	((MatrixButton)colBufferItem.elementAt(i)).setBackground(colorBuffer);
      }
      else {
	((MatrixButton)colBufferItem.elementAt(i)).setBackground(colorBackground);
      }
    }
  }

  protected int nRow = 0;
  protected int startIndex = 0;
  protected int endIndex = 0;

  protected boolean realBuffer = true;

  protected Vector colBufferItem = new Vector();

  protected Color colorBackground;
  protected Color colorBuffer;
  protected Color colorBufferUpdate;
}
