/*************************************************************************

	File Name	: OutlinePanel.java

	Author		: Kim, Dongmin

	Function	: Make a outline of the object with title.

**************************************************************************/

import java.awt.*;
import java.util.*;
import java.lang.*;
import java.awt.event.*;
import java.applet.Applet;

public class OutlinePanel extends Panel {

  protected int borderGap;
  protected boolean drawBorder = true;

  /*****************************************************************
   *
   *	method	 : OutlinePanel()
   *
   *	Function : constructor of this class
   *
   *****************************************************************/
  OutlinePanel(int borderGap) { 

    drawBorder = true;

    this.borderGap = borderGap;

    setLayout(new BorderLayout());
  }

  /*****************************************************************
   *
   *	method	 : OutlinePanel()
   *
   *	Function : constructor of this class
   *
   *****************************************************************/
  OutlinePanel(int borderGap, boolean b) { 

    drawBorder = b;

    this.borderGap = borderGap;

    setLayout(new BorderLayout());
  }

  /*****************************************************************
   *
   *	method	 : paint()
   *	Input    : Graphics g
   *	Output   : none
   *
   *****************************************************************/
  public void paint(Graphics g) {

    if ( !drawBorder ) {
      return;
    }

    Dimension r = getSize();

    /**
    g.drawLine(borderGap, borderGap, 
	       r.width - borderGap, borderGap);
    g.drawLine(borderGap, borderGap, 
	       borderGap, r.height - borderGap);
    g.drawLine(borderGap, r.height - borderGap, 
	       r.width - borderGap, r.height - borderGap);
    g.drawLine(r.width - borderGap, borderGap, 
	       r.width - borderGap, r.height - borderGap);
	       **/

    g.drawLine(0, 0, r.width, 0);
    g.drawLine(0, 0, 0, r.height);
    //g.drawLine(0, r.height, r.width, r.height);
    //g.drawLine(r.width, 0, r.width, r.height);

    g.drawLine(0, r.height - 1, r.width - 1, r.height - 1);
    g.drawLine(r.width - 1, 0, r.width - 1, r.height - 1);
  }

  /*****************************************************************
   *
   *	method	 : insets()
   *	Input    : none
   *	Output   : Insets
   *
   *****************************************************************/
  public Insets getInsets() {
    return new Insets(borderGap, borderGap, borderGap, borderGap);
  }
}
