//import javax.swing.*;
import java.awt.*;

public class SquarePanel extends java.awt.Panel {
  public SquarePanel(Color _colorLocalOld, Color _colorLocalNew) {

    colorLocalOld   = _colorLocalOld;
    colorLocalNew   = _colorLocalNew;

    setTopBackground(colorLocalOld);
    setBottomBackground(colorLocalNew);

    setLayout(new GridLayout(2, 1, 0, 0));
    add(topButton);
    add(bottomButton);	    
  }

  public SquarePanel(Color _colorBoundary, Color _colorBackground, boolean _special) {

    colorBoundary = _colorBoundary;
    colorBackground = _colorBackground;

    special = _special;

    if ( special ) { // non-north neighbor case
      setTopBackground(colorBoundary);
      setBottomBackground(colorBackground);
      setBottomForeground(colorBackground);
    }
    else {
      setTopBackground(colorBackground);
      setTopForeground(colorBackground);
      setBottomBackground(colorBoundary);
    }

    setLayout(new GridLayout(2, 1, 0, 0));
    add(topButton);
    add(bottomButton);	    
  }

  // method       : setTopBackground
  // functionality: sets the background color of the upper 
  //                part of the square
  public void setTopBackground(Color color) {
    topButton.setBackground(color);
  }

  // method       : getTopBackground
  // functionality: returns the background color of the upper 
  //                part of the square
  public Color getTopBackground() {
    return topButton.getBackground();
  }

  // method       : setTopForeground
  // functionality: sets the foreground color of the upper 
  //                part of the square	
  public void setTopForeground(Color color) {
    topButton.setForeground(color);
  }

  // method       : getTopForeground
  // functionality: returns the foreground color of the upper
  //                part of the square
  public Color getTopForeground() {
    return topButton.getForeground();
  }

  // method       : setTopText
  // functionality: sets the text to be display in the upper 
  //                part of the square
  public void setTopText(String text) {
    topButton.setText(text);
  }

  // method       : getTopText
  // functionality: returns the text to be display in the upper
  //                part of the square
  public String getTopText() {
    return topButton.getText();
  }

  // method       : setBottomBackground
  // functionality: sets the background color of the bottom
  //                part of the square	
  public void setBottomBackground(Color color) {
    bottomButton.setBackground(color);
  }

  // method       : getBottomBackground
  // functionality: returns the background color of the bottom
  //                part of the square
  public Color getBottomBackground() {
    return bottomButton.getBackground();
  }

  // method       : setBottomForeground
  // functionality: sets the foreground color of the bottom 
  //                part of the square		
  public void setBottomForeground(Color color) {
    bottomButton.setForeground(color);
  }

  // method       : getBottomForeground
  // functionality: returns the foreground color of the bottom
  //                part of the square
  public Color getBottomForeground() {
    return bottomButton.getForeground();
  }

  // method       : setBottomText
  // functionality: sets the text to be display in the bottom
  //                part of the square
  public void setBottomText(String text) {
    bottomButton.setText(text);
  }

  // method       : getBottomText
  // functionality: returns the text to be display in the bottom
  //                part of the square
  public String getBottomText() {
    return bottomButton.getText();
  }

  protected MatrixButton topButton = new MatrixButton();
  protected MatrixButton bottomButton = new MatrixButton();

  protected Color colorLocalOld;
  protected Color colorLocalNew;
  protected Color colorBoundary;
  protected Color colorBackground;

  protected boolean special;
}
