/****************************************************************************
 *      File : sports.java
 *
 *      Author : Sangyoon Oh
 *
 *      Description : 
 *	This JAVA Applet is designed for analysing the
 * 	sports-gear Market in which there are three major company. 
 *	This applet make both Bar-chart and Pie-chart using
 * 	Population, amount of money that each company make. Population is
 *	used to make a Bar-chart and Percentage of each population is used
 * 	to make a Pie-Chart. For this "sports.java", Several different method 
 * 	is used. ( init(), start(), run(), stop(), paint() and etc.  Most 
 * 	of graphics are from paint() method.   
 *
 *      Due day : Mar. 27
 ****************************************************************************/

import java.awt.*;
import java.applet.Applet;
import java.awt.event.*;

public class sports extends Applet implements Runnable {

// Declaration of variables and identifiers
	private Graphics gContext;
	private Thread thread;
	private Image buffer;
	private int each_sell[] = {0, 0, 0};
	private int net_sell = 0;
	private double perc[] = {0, 0, 0};
	private Image nike, reebok, adidas;
	private int dgr1, dgr2;
	private Font font0, font1;

	public void init()
	{
	// Initialization the buffers to use the double buffering ,
	// getting image and declaring font.
	// refered LoadImageAndScale.java at p.734
	   setBackground(Color.white);	   
	   buffer = createImage(800, 600);
	   gContext = buffer.getGraphics();
 
	   nike = getImage(getDocumentBase(), "swoosh.gif");
	   reebok = getImage(getDocumentBase(), "reebok.gif");		
           adidas = getImage(getDocumentBase(), "adidas.gif");

	   font0 = new Font("Serif", Font.PLAIN, 18);
           font1 = new Font("Courier", Font.BOLD, 24);

       	}		

	public void start()
	{
	// Create threads and start every time start is called
	// refering to mObjApplet.java by Nancy
	  if ( thread == null ) {
	     thread = new Thread( this );
	     thread.start ();
	    }
	}

        public void run ()
        {
	// Generate population using 'Math.random' 
	// sleep method must be called in a try block
	// refering to mObjApplet.java by Nancy 
         int randomnum;
	  int i;
	 	
          for (i = 0; i < 500; i++) 		// iterate 500 times
	  {
           try  {
                Thread.sleep( 500 );		// sleep 500 ns. each
                }
                catch ( InterruptedException e ) {
                   e.printStackTrace();
                }
	// randomnum gets one of three # ( since, 0 < Math.random < 1 )  
		randomnum = (int) ( Math.random() * 3 );
		++net_sell;			// increase net_sell
		++each_sell[randomnum];		// increase each_sell[]
		perc[randomnum] = (double) (each_sell[randomnum] / net_sell * 100);
		
		dgr1 = (int) ( 360 * each_sell[1] / net_sell );	// For Pie 
                dgr2 = (int) ( 360 * each_sell[2] / net_sell );

	// repaint method request a call to update method
	// this is used for reducing "flicker"
		repaint ();
         }
        } 					// End of run()
 
	public void stop ()
	{
	  // stop thread every time stop is called
          // refering to mObjApplet.java by Nancy

	  if ( thread != null ) {
	     thread.stop ();
	     thread = null;
	    }
	}

	public void update ( Graphics g )
	{
          // refering to mObjApplet.java by Nancy   

	   paint ( g );
	}

	public void paint ( Graphics g )
	{ 
	// most of this command and usage of method refered to Examples
	// which is in Chapter. 9 of JAVA: How to program. 
	  int i;
          int s;
	  String sale; 
	  String title = " Sales Analysis : Syracuse Case ";

	// set the background and rectangle
	  gContext.setFont(font0); 
	  gContext.setColor(Color.white);
	  gContext.fillRect(0, 0, 800, 600);
          gContext.setColor(Color.black); 
          gContext.drawRect(1, 1, 798, 598);

	// drawing the Image of three company
          gContext.drawImage( nike, 110, 125, this);
          gContext.drawImage( reebok, 200, 100, 75, 75, this);
          gContext.drawImage( adidas, 310, 125, this);
 
	// several strings for scale 
          gContext.drawString("Company", 25, 200);
          gContext.drawString(" 3500", 25, 220);
          gContext.drawString(" 2000", 25, 315);  
	  gContext.drawString("    0", 25, 400);
          gContext.drawString("Sale( $ )", 25, 450);

          gContext.drawString("NIKE", 110, 200);
          gContext.drawString("REEBOK", 200, 200);
          gContext.drawString("ADIDAS", 300, 200);
          gContext.drawString("MARKET SHARE ( % )", 530, 150);

	// for loop for drawing each of population
	  for ( i = 0; i < 3; i++ )
	  { 
	    s = each_sell[i] * 20;
	    sale = Integer.toString (s); 
            gContext.drawString(sale, 100 * ( i + 1 ), 450);
	  }

	// drawing the Bar-chart using fillRect and drawRect
	// for the up-rising I modified y-location.
	  gContext.setColor( Color.red );
          gContext.fillRect( 100, 400 - each_sell[0], 75, each_sell[0] );
          gContext.setColor( Color.black );
          gContext.drawRect( 100, 400 - each_sell[0], 75, each_sell[0] );
          
          gContext.setColor( Color.blue );
          gContext.fillRect( 200, 400 - each_sell[1], 75, each_sell[1] );
          gContext.setColor( Color.black );
          gContext.drawRect( 200, 400 - each_sell[1], 75, each_sell[1] );
          
          gContext.setColor( Color.black );
          gContext.fillRect( 300, 400 - each_sell[2], 75, each_sell[2] );
          gContext.setColor( Color.gray );
          gContext.drawRect( 300, 400 - each_sell[2], 75, each_sell[2] );
 
	// drawing lines for scale
	  gContext.drawLine( 90, 400, 385, 400);
          gContext.drawLine( 90, 315, 385, 315);
          gContext.drawLine( 90, 225, 385, 225);

	// drawing the Pie-chart using fillArc and drawArc
	// dgr* is already calculated in run()
          gContext.setColor( Color.red );
          gContext.fillArc( 470, 200, 250, 250, 0, 360 );
          gContext.setColor( Color.black );
          gContext.drawArc( 470, 200, 250, 250, 0, 360 );
         
          gContext.setColor( Color.blue );
          gContext.fillArc( 470, 200, 250, 250, 0, dgr1 );
          gContext.setColor( Color.black );
          gContext.drawArc( 470, 200, 250, 250, 0, dgr1 );
          
          gContext.setColor( Color.black );
          gContext.fillArc( 470, 200, 250, 250, dgr1, dgr2 );
          gContext.setColor( Color.gray );
          gContext.drawArc( 470, 200, 250, 250, dgr1, dgr2 );
	
	// new font for the title
	// Graphics setFont() at P.481
	  gContext.setFont( font1 ); 
          gContext.drawString(title, 150, 40);

	  gContext.drawLine( 30, 50, 770, 50); 

          g.drawImage(buffer, 0, 0, this);
          
	}					// End of paint()
}						// End of class
